# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetMigrationsResult',
    'AwaitableGetMigrationsResult',
    'get_migrations',
    'get_migrations_output',
]

@pulumi.output_type
class GetMigrationsResult:
    """
    A collection of values returned by getMigrations.
    """
    def __init__(__self__, compartment_id=None, display_name=None, filters=None, id=None, lifecycle_details=None, migration_collections=None, state=None):
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if lifecycle_details and not isinstance(lifecycle_details, str):
            raise TypeError("Expected argument 'lifecycle_details' to be a str")
        pulumi.set(__self__, "lifecycle_details", lifecycle_details)
        if migration_collections and not isinstance(migration_collections, list):
            raise TypeError("Expected argument 'migration_collections' to be a list")
        pulumi.set(__self__, "migration_collections", migration_collections)
        if state and not isinstance(state, str):
            raise TypeError("Expected argument 'state' to be a str")
        pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> str:
        """
        OCID of the compartment where the secret containing the credentials will be created.
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[str]:
        """
        Migration Display Name
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetMigrationsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="lifecycleDetails")
    def lifecycle_details(self) -> Optional[str]:
        """
        Additional status related to the execution and current state of the Migration.
        """
        return pulumi.get(self, "lifecycle_details")

    @property
    @pulumi.getter(name="migrationCollections")
    def migration_collections(self) -> Sequence['outputs.GetMigrationsMigrationCollectionResult']:
        """
        The list of migration_collection.
        """
        return pulumi.get(self, "migration_collections")

    @property
    @pulumi.getter
    def state(self) -> Optional[str]:
        """
        The current state of the Migration resource.
        """
        return pulumi.get(self, "state")


class AwaitableGetMigrationsResult(GetMigrationsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetMigrationsResult(
            compartment_id=self.compartment_id,
            display_name=self.display_name,
            filters=self.filters,
            id=self.id,
            lifecycle_details=self.lifecycle_details,
            migration_collections=self.migration_collections,
            state=self.state)


def get_migrations(compartment_id: Optional[str] = None,
                   display_name: Optional[str] = None,
                   filters: Optional[Sequence[pulumi.InputType['GetMigrationsFilterArgs']]] = None,
                   lifecycle_details: Optional[str] = None,
                   state: Optional[str] = None,
                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetMigrationsResult:
    """
    This data source provides the list of Migrations in Oracle Cloud Infrastructure Database Migration service.

    List all Migrations.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_migrations = oci.DatabaseMigration.get_migrations(compartment_id=%!v(PANIC=Format method: runtime error: invalid memory address or nil pointer dereference),
        display_name=%!v(PANIC=Format method: runtime error: invalid memory address or nil pointer dereference),
        lifecycle_details=%!v(PANIC=Format method: runtime error: invalid memory address or nil pointer dereference),
        state=%!v(PANIC=Format method: runtime error: invalid memory address or nil pointer dereference))
    ```


    :param str compartment_id: The ID of the compartment in which to list resources.
    :param str display_name: A filter to return only resources that match the entire display name given.
    :param str lifecycle_details: The lifecycle detailed status of the Migration.
    :param str state: The lifecycle state of the Migration.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['displayName'] = display_name
    __args__['filters'] = filters
    __args__['lifecycleDetails'] = lifecycle_details
    __args__['state'] = state
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:DatabaseMigration/getMigrations:getMigrations', __args__, opts=opts, typ=GetMigrationsResult).value

    return AwaitableGetMigrationsResult(
        compartment_id=__ret__.compartment_id,
        display_name=__ret__.display_name,
        filters=__ret__.filters,
        id=__ret__.id,
        lifecycle_details=__ret__.lifecycle_details,
        migration_collections=__ret__.migration_collections,
        state=__ret__.state)


@_utilities.lift_output_func(get_migrations)
def get_migrations_output(compartment_id: Optional[pulumi.Input[str]] = None,
                          display_name: Optional[pulumi.Input[Optional[str]]] = None,
                          filters: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetMigrationsFilterArgs']]]]] = None,
                          lifecycle_details: Optional[pulumi.Input[Optional[str]]] = None,
                          state: Optional[pulumi.Input[Optional[str]]] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetMigrationsResult]:
    """
    This data source provides the list of Migrations in Oracle Cloud Infrastructure Database Migration service.

    List all Migrations.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_migrations = oci.DatabaseMigration.get_migrations(compartment_id=%!v(PANIC=Format method: runtime error: invalid memory address or nil pointer dereference),
        display_name=%!v(PANIC=Format method: runtime error: invalid memory address or nil pointer dereference),
        lifecycle_details=%!v(PANIC=Format method: runtime error: invalid memory address or nil pointer dereference),
        state=%!v(PANIC=Format method: runtime error: invalid memory address or nil pointer dereference))
    ```


    :param str compartment_id: The ID of the compartment in which to list resources.
    :param str display_name: A filter to return only resources that match the entire display name given.
    :param str lifecycle_details: The lifecycle detailed status of the Migration.
    :param str state: The lifecycle state of the Migration.
    """
    ...
